//
//  MyDocument.m
//  Notes
//
//  Created by Heiko W. Rupp on 12.01.08.
//  Copyright __MyCompanyName__ 2008 . All rights reserved.
//

#import "MyDocument.h"


@implementation MyDocument



- (id)init
{
	printf("init\n");
    self = [super init];
    if (self) {
    
        // Add your subclass-specific initialization here.
        // If an error occurs here, send a [self release] message and return nil.
		if (mString == nil) {
			mString = [[NSAttributedString alloc] initWithString:@""];
		}
		
		preferences = [[NSUserDefaults standardUserDefaults] retain];
		name = nil;
    }
    return self;
}

-  (id)initWithContentsOfURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError
{
	printf("init with contents"	);
	// Instantiate ourself
	self = [[MyDocument alloc] init];
	
	// load the file
	NSString *content = [NSString stringWithContentsOfURL:absoluteURL];
	int index = [content rangeOfString:@"\n\n"].location;	
	
	headers = [[[content substringToIndex:index] componentsSeparatedByString:@"\n"] retain];
	NSString *body = [content substringFromIndex:index+2];
	
	// Initialize body text
	[mString initWithString:body];
	
	// extract the name
	NSString *relPath = [absoluteURL relativePath];
	name = [[relPath lastPathComponent] retain]; 
	
	return self;
}


- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
		printf("nib loaded ..\n");

    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
	if ([self string] != nil) {
		[[textField textStorage] setAttributedString: [self string]];
	}
	// TODO do this via bindings
	if (headers != nil) {
		int i;
		for (i = 0; i < 3 ; i++ ) {
			NSFormCell *fc = [fields cellAtIndex:i];
			NSString *line = [headers objectAtIndex:i];
			int index = [line rangeOfString:@" "].location;
			line = [line substringFromIndex:index + 1];
			// TODO only take the value here
			[fc setStringValue:line];
		}
	}
	
	printf("wCDLN\n");
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API -dataOfType:error:.  In this case you can also choose to override -writeToURL:ofType:error:, -fileWrapperOfType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.
	
    NSData *data;
    [self setString:[textField textStorage]];
    data = [NSArchiver archivedDataWithRootObject:[self string]];
    return data;

}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
	
	NSAttributedString *tempString = [NSUnarchiver unarchiveObjectWithData: data];
    [self setString:tempString];
    return YES;
    
}

- (IBAction)saveDocument:(id)sender
{
	printf("save\n");
	NSTextStorage *storage = [textField textStorage];
	NSString *foo = [storage string];
	printf("%@" , foo);
	
	if (name == nil) 
	{
		int num = [preferences integerForKey:@"id"];
		num++;
		[preferences setInteger:num forKey:@"id"];
		[preferences synchronize];
		name = [[NSString stringWithFormat:@"%05d.txt" , num] retain];
	}
		
	
		
	[window setTitle:name]; // TODO use the windowController for this
	
	NSString *path = [@"~/Library/QNotes/" stringByExpandingTildeInPath];
	[[NSFileManager defaultManager] createDirectoryAtPath:path attributes:nil];
	path = [[path stringByAppendingString:@"/"] stringByAppendingString:name];
	int i = 0;
	NSString *out = [[NSString alloc] init];
	for (i = 0; i < 3 ; i++ ) {
		NSFormCell *fc = [fields cellAtIndex:i];
		NSString *title = [fc title];
		NSString *value = [fc stringValue];
		out = [out stringByAppendingString:title];
		out = [out stringByAppendingString:@" "];
		out = [out stringByAppendingString:value];
		out = [out stringByAppendingString:@"\n"];
		
	}
	out = [out stringByAppendingString:@"\n"];
	out = [out stringByAppendingString:foo];
	[out writeToFile:path atomically:NO];
	printf("\n");
 
}

- (NSAttributedString *) string { return [[mString retain] autorelease]; }
 
- (void) setString: (NSAttributedString *) newValue {
    if (mString != newValue) {
        if (mString) [mString release];
        mString = [newValue copy];
    }
}

- (void) textDidChange: (NSNotification *) notification
{
    [self setString: [textField textStorage]];
}

@end
